<?php
include_once("Functions/Logs.php");
include_once(dirname(__DIR__).'/vendor/autoload.php');

use Automattic\WooCommerce\Client;

$dotenv = Dotenv\Dotenv::createImmutable(dirname(__DIR__));
$dotenv->load();


class Queries
{
    public function __construct()
    {
        $this->session = null;
        $this->connect();
    }
    
    protected function connect()
    {

        $this->session = new mysqli($_ENV['SERVER_NAME'],$_ENV['DB_USER_NAME'],$_ENV['DB_PASSWORD'],$_ENV['DB_NAME']);

        if ($this->session->connect_errno) {
            echo "Failed to connect to MySQL: " . mysqli_connect_error();
            exit();
        }

        return $this->session;
    }

    public function checkIsItemActive($tableName, $itemField, $itemId)
    {
        $result = $this->session->query("SELECT active FROM $tableName WHERE $itemField='$itemId'");

        if ($result->num_rows > 0) {
            return $result->fetch_row()[0];
        }else {
            return false;
        }
        
    }

    public function checkSysModifiedDateItem($tableName, $itemField, $itemId)
    {
        $result = $this->session->query("SELECT sysModifiedDate FROM $tableName WHERE $itemField='$itemId'");

        if ($result->num_rows > 0) {
            return $result->fetch_row()[0];
        }else {
            return false;
        }
        
    }

    public function checkItemExist($tableName, $itemField, $itemId)
    {
        $result = $this->session->query("SELECT `$itemField` FROM `$tableName` WHERE `$itemField`='$itemId'");

        if ($result->num_rows > 0) {
            return $result->fetch_row()[0];
        }else {
            return false;
        }
        
    }

    public function updateSysModifiedDateItem($tableName, $itemField, $itemId, $sysModifiedDate, $active)
    {
        $currentDate = date('Y-m-d H:i:s');
        $result = $this->session->query("UPDATE $tableName SET `active`='$active', `sysModifiedDate`='$sysModifiedDate', `modified_at`='$currentDate' WHERE `$itemField`='$itemId'");

        if ($result) {
            return true;
        }else {
            return false;
        }
        
    }

    public function addItem($tableName, $itemField, $itemId, $sysModifiedDate, $active)
    {
        $result = $this->session->query("INSERT INTO $tableName (`$itemField`, `active`, `sysModifiedDate`) VALUES ('$itemId', '$active', '$sysModifiedDate')");

        if ($result) {
            return true;
        }else {
            return false;
        }
        
    }

    public function setActiveItemField($tableName, $itemField, $itemId, $active)
    {
        $currentDate = date('Y-m-d H:i:s');
        $result = $this->session->query("UPDATE $tableName SET `active`='$active', `modified_at`='$currentDate' WHERE `$itemField`='$itemId'");

        if ($result) {
            return true;
        }else {
            return false;
        }
        
    }


    public function UpdateTranscoInvoices($IdEBP,$DocumentNumber,$ValidationState,$DocumentState,$SettlementModeId,$DocumentDate)
    {
        $query = 'INSERT INTO `invoices`(`idebp`, `DocumentNumber`, `ValidationState`, `DocumentState`, `SettlementModeId`, `DocumentDate`, `dateinsertion`, `statinsertion`) VALUES ("'.$IdEBP.'","'.$DocumentNumber.'","'.$ValidationState.'","'.$DocumentState.'","'.$SettlementModeId.'","'.$DocumentDate.'",NOW(),"1")';
        $result = $this->session->query($query);
        if ($result) {
            return '[SUCCESS] Invoice :'.$DocumentNumber.' Inserted. Request : INSERT INTO `invoices`(`idebp`, `DocumentNumber`, `ValidationState`, `DocumentState`, `SettlementModeId`, `DocumentDate`, `dateinsertion`, `statinsertion`) VALUES ("'.$IdEBP.'","'.$DocumentNumber.'","'.$ValidationState.'","'.$DocumentState.'","'.$SettlementModeId.'","'.$DocumentDate.'",NOW(),"1")<br><br>';
        }else {
            return '[ERROR] Invoice :'.$DocumentNumber.' Inserted. Request : INSERT INTO `invoices`(`idebp`, `DocumentNumber`, `ValidationState`, `DocumentState`, `SettlementModeId`, `DocumentDate`, `dateinsertion`, `statinsertion`) VALUES ("'.$IdEBP.'","'.$DocumentNumber.'","'.$ValidationState.'","'.$DocumentState.'","'.$SettlementModeId.'","'.$DocumentDate.'",NOW(),"1")<br><br>';
        }
    }


    public function TranscoCustomers($id,$name,$mail,$tel,$contactname,$contactforename,$Address1,$ZipCode,$City)
    {
        $query = 'INSERT INTO `customers`(`idsellsy`, `name`, `importtime`,`updated`,`mail`,`tel`,`contactname`,`contactforename`,`adr`,`zip`,`city`) VALUES ('.$id.',"'.$name.'",NOW(),22,"'.$mail.'","'.$tel.'","'.$contactname.'","'.$contactforename.'","'.$Address1.'","'.$ZipCode.'","'.$City.'")';
        $result = $this->session->query($query);
        if ($result) {
            return "Inserted [Customer] Request : ".$query;
        }else{
            return "Not inserted [Customer] Request : ".$query;
        }
            
        
    }


    public function CheckDuplicated()
    {
        $result = $this->session->query("SELECT GROUP_CONCAT(idsellsy) AS duplicate_idsellsy FROM customers GROUP BY name HAVING COUNT(*) > 1;");

        if ($result->num_rows > 0) {
            $duplicates = array();
            while ($row = $result->fetch_assoc()) {
                $duplicates[] = $row['duplicate_idsellsy'];
            }
            return $duplicates;
        } else {
            return false;
        }
    }


    public function getCustomers()
    {
        $result = $this->session->query("SELECT idsellsy FROM customers WHERE DATE(importtime) != CURDATE() AND DATE(importtime) != CURDATE() - INTERVAL 1 DAY;");
    
        if ($result->num_rows > 0) {
            $customers = array();
            while ($row = $result->fetch_assoc()) {
                $customers[] = $row['idsellsy'];
            }
            return $customers;
        } else {
            return false;
        }
    }

    public function getCustomerstoDelete()
    {
        $result = $this->session->query("SELECT idsellsy FROM `customers` WHERE `importtime` >= '2023-06-10 16:00:00'");
    
        if ($result->num_rows > 0) {
            $customers = array();
            while ($row = $result->fetch_assoc()) {
                $customers[] = $row['idsellsy'];
            }
            return $customers;
        } else {
            return false;
        }
    }
    

    public function UpdateCustomers($mail,$tel,$contactname,$contactforename,$idsellsy)
    {
        $result = $this->session->query("UPDATE `customers` SET `mail`='$mail',`tel`='$tel',`contactname`='$contactname',`contactforename`='$contactforename',`updated`=1 WHERE idsellsy=$idsellsy");
        if ($result) {
            return "UPDATE `customers` SET `mail`='$mail',`tel`='$tel',`contactname`='$contactname',`contactforename`='$contactforename',`updated`=1 WHERE idsellsy=$idsellsy";
        }else {
            return "UPDATE `customers` SET `mail`='$mail',`tel`='$tel',`contactname`='$contactname',`contactforename`='$contactforename',`updated`=1 WHERE idsellsy=$idsellsy";
        }
    }

    public function UpdateCustomersAdr($adr,$zip,$city,$idsellsy)
    {
        $result = $this->session->query("UPDATE `customers` SET `importtime`=NOW(), `adr`='$adr',`zip`='$zip',`city`='$city' WHERE idsellsy=$idsellsy");
        if ($result) {
            return "UPDATE `customers` SET `importtime`=NOW(),`adr`='$adr',`zip`='$zip',`city`='$city' WHERE idsellsy=$idsellsy";
        }else {
            return "UPDATE `customers` SET `importtime`=NOW(), `adr`='$adr',`zip`='$zip',`city`='$city' WHERE idsellsy=$idsellsy";
        }
    }

    public function getCustomerID($name)
    {
        $result = $this->session->query('SELECT idsellsy FROM customers WHERE `name`="'.$name.'" LIMIT 1');
        if ($result->num_rows > 0) {
            return $result->fetch_row()[0];
        }
    }
    
    public function getDocumentCustomer($name,$address1,$zipcode,$city,$DeliveryContact_Email,$DeliveryContact_Name,$DeliveryContact_Phone,$DeliveryContact_FirstName)
    {
        // $result = $this->session->query("SELECT idsellsy FROM customers WHERE `adr`='$address1' and `zip`='$zipcode' and `city`='$city' limit 1;");
        // $result = $this->session->query("SELECT idsellsy FROM customers WHERE `name`='$name' and `zip`='$zipcode' and `city`='$city' limit 1;");
        // $result = $this->session->query('SELECT idsellsy FROM customers WHERE name="'.$name.'" and adr ="'.$Address1.'" and zip ="'.$ZipCode.'" and city ="'.$City.'" limit 1');
        // $result = $this->session->query('SELECT idsellsy FROM customers WHERE name="'.$name.'" and mail ="'.$mail.'" limit 1');
        // $result = $this->session->query('SELECT idsellsy FROM customers WHERE name="'.$name.'" and mail ="'.$mail.'" and contactname="'.$contactname.'" limit 1');
        // $result = $this->session->query('SELECT idsellsy FROM customers WHERE mail ="'.$DeliveryContact_Email.'" and contactname="'.$DeliveryContact_Name.'" and tel="'.$DeliveryContact_Phone.'" limit 1');
        // $result = $this->session->query('SELECT idsellsy FROM customers WHERE name="'.$name.'" and contactname="'.$contactname.'" limit 1');
        $result = $this->session->query('SELECT idsellsy FROM customers WHERE `name`="'.$name.'" and `zip`="'.$zipcode.'" and `city`="'.$city.'" LIMIT 1');
        if ($result->num_rows > 0) {
            return $result->fetch_row()[0];
        }
        
        $result = $this->session->query('SELECT idsellsy FROM customers WHERE `adr`="'.$address1.'" and `zip`="'.$zipcode.'" and `city`="'.$city.'" LIMIT 1');
        if ($result->num_rows > 0) {
            return $result->fetch_row()[0];
        }
        
        $result = $this->session->query('SELECT idsellsy FROM customers WHERE mail ="'.$DeliveryContact_Email.'" and contactname="'.$DeliveryContact_Name.'" and tel="'.$DeliveryContact_Phone.'" LIMIT 1');
        if ($result->num_rows > 0) {
            return $result->fetch_row()[0];
        }
        
        $result = $this->session->query('SELECT idsellsy FROM customers WHERE name="'.$name.'" and adr ="" and zip ="" and city = "" LIMIT 1');
        if ($result->num_rows > 0) {
            return $result->fetch_row()[0];
        }
        
        $result = $this->session->query('SELECT idsellsy FROM customers WHERE name="'.$name.'" LIMIT 1');
        if ($result->num_rows > 0) {
            return $result->fetch_row()[0];
        }
        
        $result = $this->session->query('SELECT idsellsy FROM customers WHERE name LIKE "%'.$name.'%" LIMIT 1');
        if ($result->num_rows > 0) {
            return $result->fetch_row()[0];
        }

        $result = $this->session->query('SELECT idsellsy FROM customers WHERE contactname="'.$DeliveryContact_Name.'" and contactforename="'.$DeliveryContact_FirstName.'" LIMIT 1');
        if ($result->num_rows > 0) {
            return $result->fetch_row()[0];
        }

        $result = $this->session->query('SELECT idsellsy FROM customers WHERE mail ="'.$DeliveryContact_Email.'" or tel="'.$DeliveryContact_Phone.'" LIMIT 1');
        if ($result->num_rows > 0) {
            return $result->fetch_row()[0];
        }
        
        return false;
        
    }


    public function getDocumentCustomerCount($name)
    {
        $result = $this->session->query('SELECT count(*) FROM customers WHERE name="'.$name.'"');
        // $result = $this->session->query('SELECT idsellsy FROM customers WHERE name="'.$name.'" and contactname="'.$contactname.'" limit 1');

        if ($result->num_rows > 0) {
            return $result->fetch_row()[0];
        }else {
            return false;
        }
        
    }


    public function checkcustomer($filename,$customerName)
    {
        $exportDirectory = '/var/www/html/EBP_SAAS/inforiel/EDIConnect_EBP/Exports/Customers/release';
        $importDirectory = '/var/www/html/EBP_SAAS/inforiel/EDIConnect_EBP/Imports/Customers';

        $result = $this->session->query('SELECT id FROM customers WHERE name="'.$customerName.'"');

        if ($result->num_rows == 0) {
            // Customer name does not exist in the database
            $file = 'customer_'.$customerName.'.csv';
            $destinationPath = $importDirectory . '/' . $file;
            if (copy($exportDirectory . '/' . $filename, $destinationPath)) {
                echo "File copied successfully to $destinationPath<br>";
            } else {
                echo "Failed to copy the file to $destinationPath<br>";
            }

        }
        
    }


    public function getInvoices()
    {
        $result = $this->session->query("SELECT DocumentNumber,ValidationState FROM `invoices` WHERE `statinsertion` = '1'");
    
        if ($result->num_rows > 0) {
            $invoices = array();
            while ($row = $result->fetch_assoc()) {
                $invoices[] = array(
                    'DocumentNumber' => $row['DocumentNumber'],
                    'ValidationState' => $row['ValidationState']
                );
            }
            return $invoices;
        } else {
            return false;
        }
    }


    
    public function updateInvoicesData($documentNumber,$id,$validationState)
    {
        $result = $this->session->query("UPDATE `invoices` SET `dateupdate`=NOW(),`statinsertion`='$validationState',`idsellsy`='$id' WHERE DocumentNumber='$documentNumber'");
        if ($result) {
            return "[SUCCESS] Invoice : ".$documentNumber.", Udpated. UPDATE `invoices` SET `dateupdate`=NOW(),`statinsertion`='".$validationState."',`idsellsy`='".$id."' WHERE DocumentNumber='".$documentNumber."'<br>";
        }else {
            return "[REQUEST] Invoice : ".$documentNumber.", NOT Udpated. UPDATE `invoices` SET `dateupdate`=NOW(),`statinsertion`='".$validationState."',`idsellsy`='".$id."' WHERE DocumentNumber='".$documentNumber."'<br>";
        }
    }
}
