<?php
include_once($_ENV["EDICONNECT_EBP"]."Functions/Logs.php");
include_once($_ENV["EDICONNECT_EBP"]."Functions/Functions.php");
include_once($_ENV["EDICONNECT_EBP"]."Configurations/api.php");
include_once($_ENV["EDICONNECT_EBP"]."Configurations/api_sellsy.php");
include_once($_ENV["EDICONNECT_EBP"]."Class/queries.class.php");


class CustomersController
{
    
    public function __construct(){
        $this->APIAuth = new APIAuth();

        $this->SellsyAPIAuth = new SellsyAPIAuth();

        $this->access_token = $this->APIAuth->access_token;
        $this->refresh_token =  $this->APIAuth->refresh_token;

        $this->ebp_subscription_key = $this->APIAuth->ebp_subscription_key;
        $this->sellsy_access_token = $this->SellsyAPIAuth->access_token;


    }

    
    public function customersListToExport(){

        $logs = new Logs();

        try {
            $date = date("YmdHis");
            $error_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Errors/ERROR_CUSTOMER_$date.txt";

            $offset = 0;
            $customers = [];

    
            do {
                $url = $this->APIAuth->GetApiPathCustomersListToExport($offset);
                $curl = curl_init();
        
                curl_setopt_array($curl, array(
                    CURLOPT_URL => $url,
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_ENCODING => "",
                    CURLOPT_MAXREDIRS => 10,
                    CURLOPT_TIMEOUT => 0,
                    CURLOPT_FOLLOWLOCATION => true,
                    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                    CURLOPT_CUSTOMREQUEST => "GET",
                    CURLOPT_HTTPHEADER => array(
                        "ebp-subscription-key: $this->ebp_subscription_key",
                        "Authorization: Bearer $this->access_token"
                    ),
                ));
        
                $resp = json_decode(curl_exec($curl),true);
                $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
                curl_close($curl);

                if ($http_code == "200") {
                    $customers = array_merge($customers, $resp["results"]);
                }else{ 
                    echo "Error : ".$http_code." <br> Please check your access TOKEN KEY's to the API.";
        
                    $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Errors/ERROR_CUSTOMER_$date.txt";
                    $file = fopen($error_path, "a");
                    $logs->addLog($file, "EXPORT CLIENT", "Erreur avec la requete cURL lors de l'export de clients (Erreur $http_code)", "ERROR");
                }

                $offset += 500;
            } while ($resp["paging"]["total"] > 0);

            if (count($customers) > 0) {
                $queries = new Queries();
                
                foreach ($customers as $customer) {

                    if (trim($customer["MainInvoicingContact_Email"]) != "") {
                            
                        $result = $queries->checkSysModifiedDateItem("customers_syncro", "customer_id", $customer["Id"]);
                
                        if (!$result) {
                            $isFileGenerated = $this->Export($customer["Id"]);
                            if ($isFileGenerated) {
                                $message = "Fichier d'export généré pour le client ".$customer["Id"];
                                $success_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Exports/SUCCESS_CUSTOMER_".$customer["Id"]."_$date.txt";
                                $file = fopen($success_path, "a");
                                $logs->addLog($file, "EXPORT CLIENT", $message, "SUCCESS");
                            }else {
                                $message = "Fichier d'export non généré pour le client ".$customer["Id"];
                                $error_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Exports/Errors/ERROR_CUSTOMER_".$customer["Id"]."_$date.txt";
                                $file = fopen($error_path, "a");
                                $logs->addLog($file, "EXPORT CLIENT", $message, "ERROR");

                            }
                        }
                        
                        if ($result && $customer["sysModifiedDate"] !== $result) {
                            $isFileGenerated = $this->Export($customer["Id"]);
                            if ($isFileGenerated) {
                                $message = "Fichier d'export généré pour le client ".$customer["Id"];
                                $success_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Exports/SUCCESS_CUSTOMER_".$customer["Id"]."_$date.txt";
                                $file = fopen($success_path, "a");
                                $logs->addLog($file, "EXPORT CLIENT", $message, "SUCCESS");
                            }else {
                                $message = "Fichier d'export non généré pour le client ".$customer["Id"];
                                $error_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Exports/Errors/ERROR_CUSTOMER_".$customer["Id"]."_$date.txt";
                                $file = fopen($error_path, "a");
                                $logs->addLog($file, "EXPORT CLIENT", $message, "ERROR");
                            }
                        }
                        $queries->setActiveItemField("customers_syncro", "customer_id", $customer["Id"], 1);
                    }else {
                        $message = "Fichier d'export non généré pour le client ".$customer["Id"] ." => Le champ 'Email de facturation' est vide.";
                        $error_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Exports/Errors/ERROR_CUSTOMER_".$customer["Id"]."_$date.txt";
                        $file = fopen($error_path, "a");
                        $logs->addLog($file, "EXPORT CLIENT", $message, "ERROR");
                    }
                }
    
                require_once($_ENV["WORDPRESS_API"]."customers/export.php");
            }   

        } catch (\Throwable $th) {
            //throw $th;
            $date = date("YmdHis");
    
            $error_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Exports/Errors/ERROR_CUSTOMER_$date.txt";
            $file = fopen($error_path, "a");
            $logs->addLog($file, "EXPORT CLIENT", $th->getMessage(), "ERROR");

        }
    } 

    public function Export($customerId){

        try {
            $url = $this->APIAuth->GetApiPathCustomersExport($customerId);
            $curl = curl_init();

            curl_setopt_array($curl, array(
                CURLOPT_URL => $url,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "GET",
                CURLOPT_HTTPHEADER => array(
                    "ebp-subscription-key: $this->ebp_subscription_key",
                    "Authorization: Bearer $this->access_token"
                ),
            ));

            $resp = curl_exec($curl);

            $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
            curl_close($curl);

            if($http_code == "200"){ 
                include_once($_ENV["EDICONNECT_EBP"]."Models/CustomersModel.php");
                $CustomerModel = new CustomerModel();
                $result = json_decode($resp,true);
                return $CustomerModel->Export($result);
            }else{ 
                echo "Error : ".$http_code." <br> Please check your access TOKEN KEY's to the API.";
                return false;
            }
        } catch (\Throwable $th) {
            //throw $th;
            $date = date("YmdHis");
    
            $error_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Exports/Errors/ERROR_CUSTOMER_$date.txt";
            $file = fopen($error_path, "a");
            $logs->addLog($file, "EXPORT CLIENT", $th->getMessage(), "ERROR");
            return false;
        }
    } 


    public function deleteDuplicateFiles(){
        $directory = $_ENV["EDICONNECT_EBP"] . "/Exports/Customers/Success_2/";
        $files = glob($directory . '*customer-*.csv');
        $unique_customers = [];
        foreach ($files as $file) {
            preg_match('/.*customer-(.*?)-.*\.csv$/', $file, $matches);
            $customer_name = isset($matches[1]) ? $matches[1] : '';
            if (!isset($unique_customers[$customer_name])) {
                $unique_customers[$customer_name] = $file;
            } else {
                unlink($file);
                echo "DUPLICATE : ".$file."<br>";
            }
        }
    }

    public function exportAll(){
        include_once($_ENV["EDICONNECT_EBP"]."Models/CustomersModel.php");
        $CustomerModel = new CustomerModel();

        include_once($_ENV["EDICONNECT_EBP"]."Functions/Logs.php");

        $logs = new Logs();

        try {
            $date = date("YmdHis");
            $error_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Errors/ERROR_CUSTOMER_$date.txt";

            $customers = [];

            // $url = $this->APIAuth->getApiPathAllCustomersToExport($offset);
            // $curl = curl_init();
    
            // curl_setopt_array($curl, array(
            //     CURLOPT_URL => $url,
            //     CURLOPT_RETURNTRANSFER => true,
            //     CURLOPT_ENCODING => "",
            //     CURLOPT_MAXREDIRS => 10,
            //     CURLOPT_TIMEOUT => 0,
            //     CURLOPT_FOLLOWLOCATION => true,
            //     CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            //     CURLOPT_CUSTOMREQUEST => "GET",
            //     CURLOPT_HTTPHEADER => array(
            //         "ebp-subscription-key: $this->ebp_subscription_key",
            //         "Authorization: Bearer $this->access_token"
            //     ),
            // ));
    
            // $resp = json_decode(curl_exec($curl),true);
            // $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
            // curl_close($curl);

            // if ($http_code == "200") {
            //     $customers = array_merge($customers, $resp["results"]);
                
            // }else{ 
            //     echo "Error : ".$http_code." <br> Please check your access TOKEN KEY's to the API.";
    
            //     $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Errors/ERROR_CUSTOMER_$date.txt";
            //     $file = fopen($error_path, "a");
            //     $logs->addLog($file, "EXPORT CLIENT", "Erreur avec la requete cURL lors de l'export de clients (Erreur $http_code)", "ERROR");
            // }

            // if (count($customers) > 0) {
            //     $CustomerModel->exportAll($customers);
            //     echo "<br>Generating files<br>";
            // }  

            $offset = 0;//45798; //27316;

            $errors = 0;
            $index = 1;
    
            $is_export_done = false;
            try {
                // do {                
                    $url = $this->APIAuth->getApiPathAllCustomersToExport($offset);
                    $curl = curl_init();
            
                    curl_setopt_array($curl, array(
                        CURLOPT_URL => $url,
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "GET",
                        CURLOPT_HTTPHEADER => array(
                            "ebp-subscription-key: $this->ebp_subscription_key",
                            "Authorization: Bearer $this->access_token"
                        ),
                    ));
            
                    $resp = json_decode(curl_exec($curl),true);
                    $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
                    curl_close($curl);
        
                    if ($http_code == "200") {
                        $customers = $resp["results"];

                        $CustomerModel->exportAll($customers);

                        // $offset += 100;
                        
                        // if ($resp["paging"]["total"] == 0) {
                        //     $is_export_done = true;
                        // }
                    }else{ 
                        $errors++;
                        $tokens = $this->APIAuth->getAccessTokenFromRefreshToken($this->refresh_token);
                        $this->access_token = $tokens["access_token"];
                        $this->refresh_token = $tokens["refresh_token"];
    
                        
                        echo "Error : ".$http_code." <br> Please check your access TOKEN KEY's to the API.";
            
                        $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Errors/ERROR_CUSTOMER_$date.txt";
                        $file = fopen($target_path, "a");
                        $logs->addLog($file, "EXPORT CLIENT", "Erreur avec la requete cURL lors de l'export de clients (Erreur $http_code)", "ERROR");
                    }
        
                // } while ($is_export_done == false);
        
                echo "INDEX : ".$index;
            } catch (\Throwable $th) {
                //throw $th;
                // $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Invoices/Exports/Errors/ERROR_INVOICES_$date.txt";
                // $file = fopen($target_path, "a");
                // $logs->addLog($file, "EXPORT FACTURE", $th->getMessage(), "ERROR");
    
                echo '<pre>';
                var_dump($th);
                echo '</pre>';
                echo "INDEX : ".$index;
    
            }

            //YOUVA SCRIPTE BULK EXPORT
            // $index = 1;
            // for($i = 0;$i<92;$i++) {
            //     $url = $this->APIAuth->getApiPathAllCustomersToExport($offset);
            //     $curl = curl_init();
            //     $customers = [];
            //     curl_setopt_array($curl, array(
            //         CURLOPT_URL => $url,
            //         CURLOPT_RETURNTRANSFER => true,
            //         CURLOPT_ENCODING => "",
            //         CURLOPT_MAXREDIRS => 10,
            //         CURLOPT_TIMEOUT => 0,
            //         CURLOPT_FOLLOWLOCATION => true,
            //         CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            //         CURLOPT_CUSTOMREQUEST => "GET",
            //         CURLOPT_HTTPHEADER => array(
            //             "ebp-subscription-key: $this->ebp_subscription_key",
            //             "Authorization: Bearer $this->access_token"
            //         ),
            //     ));
        
            //     $resp = json_decode(curl_exec($curl),true);
            //     $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
            //     curl_close($curl);

            //     if ($http_code == "200") {
            //         // $customers = $resp["results"];
            //         // $index += count($customers);
            //         // if (count($customers) > 0) {
            //         //     include_once($_ENV["EDICONNECT_EBP"]."Models/CustomersModel.php");
            //         //     $CustomerModel = new CustomerModel();
            //         //     $CustomerModel->exportAll($customers);
            //         //     echo "<br>Generating files<br>";
            //         // }  

            //         $customers = $resp["results"];
            //         foreach ($customers as $customer) {
            //             $customerId = $customer["Id"];
            //             $current_date = date('dmyHis');
            //             $filepath = $_ENV["EDICONNECT_EBP"] . "/Exports/Customers/Success_2/";
            //             $filename = $index."-customer-".$customerId."-".$current_date.".csv";
            //             $file_import_path = $filepath . $filename;

            //             $new_file = fopen($file_import_path, 'a');
            //             $file_line = "";

            //             foreach ($customer as $key => $value) {
            //                 $value = trim(preg_replace('/\s\s+/', ' ', $value));
            //                 $file_line .= "$key;$value\n";
            //             }
            //             fputs($new_file, $file_line);
            //             echo $index.' => '.$customer["Id"].'<br>';
            //             fclose($new_file);
            //             $index++;
            //         }

            //     }else{ 
            //         echo "Error : ".$http_code." <br> Please check your access TOKEN KEY's to the API. ".$url."<br>";
        
            //         $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Errors/ERROR_CUSTOMER_$date.txt";
            //         $file = fopen($error_path, "a");
            //         $logs->addLog($file, "EXPORT CLIENT", "Erreur avec la requete cURL lors de l'export de clients (Erreur $http_code)", "ERROR");
            //     }

            //     $offset += 500;

            // } //while ($index < 45826);
            echo "INDEX : ".$index;

//45817 total clients

            // $index=1;
            // for ($page = 1; $page <= 460; $page++) {
            //     $offset = ($page - 1) * 100;
            //     $url = $this->APIAuth->getApiPathAllCustomersToExport($offset);
            //     $curl = curl_init();

            //     curl_setopt_array($curl, array(
            //         CURLOPT_URL => $url,
            //         CURLOPT_RETURNTRANSFER => true,
            //         CURLOPT_ENCODING => "",
            //         CURLOPT_MAXREDIRS => 10,
            //         CURLOPT_TIMEOUT => 0,
            //         CURLOPT_FOLLOWLOCATION => true,
            //         CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            //         CURLOPT_CUSTOMREQUEST => "GET",
            //         CURLOPT_HTTPHEADER => array(
            //             "ebp-subscription-key: $this->ebp_subscription_key",
            //             "Authorization: Bearer $this->access_token"
            //         ),
            //     ));

            //     $resp = json_decode(curl_exec($curl),true);
            //     $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
            //     curl_close($curl);
            //     if ($http_code == "200") {                    
            //         $customers = $resp["results"];
            //         foreach ($customers as $customer) {
            //             $customerId = $customer["Id"];
            //             $current_date = date('dmyHis');
            //             $filepath = $_ENV["EDICONNECT_EBP"] . "/Exports/Customers/Success_2/";
            //             $filename = $index."-customer-".$customerId."-".$current_date.".csv";
            //             $file_import_path = $filepath . $filename;

            //             $new_file = fopen($file_import_path, 'a');
            //             $file_line = "";

            //             foreach ($customer as $key => $value) {
            //                 $value = trim(preg_replace('/\s\s+/', ' ', $value));
            //                 $file_line .= "$key;$value\n";
            //             }
            //             fputs($new_file, $file_line);
            //             echo $index.' => '.$customer["Id"].'<br>';
            //             fclose($new_file);
            //             $index++;
            //         }
            //     } else { 
            //         echo "Error : ".$http_code." <br> Please check your access TOKEN KEY's to the API. ".$url."<br>";
            //         $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Errors/ERROR_CUSTOMER_$date.txt";
            //         $file = fopen($error_path, "a");
            //         $logs->addLog($file, "EXPORT CLIENT", "Erreur avec la requete cURL lors de l'export de clients (Erreur $http_code)", "ERROR");
            //     }

            //     if ($offset % 500 == 0) {
            //         sleep(10);
            //     }
            //     sleep(3);
            // }

            


        } catch (\Throwable $th) {
            //throw $th;
            $date = date("YmdHis");
    
            $error_path = $_ENV["EDICONNECT_EBP"]."Logs/Customers/Exports/Errors/ERROR_CUSTOMER_$date.txt";
            $file = fopen($error_path, "a");
            $logs->addLog($file, "EXPORT CLIENT", $th->getMessage(), "ERROR");
            return false;
        }
    } 

    public function Import(){      
        
        $url = $this->APIAuth->GetApiPathCustomerImport();

        $functions = new Functions();
        $logs = new Logs();

        $this_dir = dirname(__FILE__);
        $parent_dir = realpath($this_dir . '/..');
        $import_dir = $_ENV["EDICONNECT_EBP"]."Imports/Customers";
        $files = glob("$import_dir/*.csv");        

        foreach($files as $filepath) {

            if ($handle = fopen($filepath, "r")) {
                $first_line_data = fgetcsv($handle,1000,";");
                $client_ref = $first_line_data[0];


                $curl = curl_init();
                curl_setopt_array($curl, array(
                CURLOPT_URL => $url,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS => array('file'=> new CURLFILE($filepath)),
                CURLOPT_HTTPHEADER => array(
                        "ebp-subscription-key: $this->ebp_subscription_key",
                        "Authorization: Bearer $this->access_token"
                    ),
                ));

                $response = curl_exec($curl);
                $response = json_decode($response);

                if ($importId = $response->importId) {
                    do {
                        $importInfo = $functions->getImportInfo($importId, $this->access_token, $this->ebp_subscription_key);
                    } while ($importInfo->status === "Starting" || $importInfo->status === "Waiting");

                    $date = date("YmdHis");
                    $nb_errors = $importInfo->importInfos->itemError;

      
                    if ($importInfo->status === "Completed") {
                        if ($nb_errors == 0) {
                            $target_path = $parent_dir . "Logs/Customers/Imports/SUCCESS_CUSTOMER_$client_ref" . "_$date.txt";
                            $file = fopen($target_path, "a");
                            $logs->writeImportLog($file, $importInfo, "success");
                            
                            unlink($filepath);
                        }else {
                            $target_path = $parent_dir . "Logs/Customers/Imports/ERROR_CUSTOMER_$client_ref" . "_$date.txt";
                            $file = fopen($target_path, "a");
                            $logs->writeImportLog($file, $importInfo, "error");
                        }
                    }
                }
                curl_close($curl);
            }
            fclose($filepath);
        }
    } 

    
    public function ImportToSellsy(){ 

        $url = $this->SellsyAPIAuth->GetApiPathClientsToImport();
        // $functions = new Functions();
        // $logs = new Logs();

        $this_dir = dirname(__FILE__);
        $parent_dir = realpath($this_dir . '/..');
        $import_dir = $_ENV["EDICONNECT_EBP"]."Imports/Customers";
        $FiletranscoCustomersSellsy = $_ENV["EDICONNECT_EBP"]."TranscoSellsy/Customers.json";
        $ArrayTranscoCustomersSellsy = array();
        
        $files = glob("$import_dir/*.csv");        
        
        foreach($files as $filepath) {

                if (($handle = fopen($filepath, "r")) !== false) {
                    $data = array();
                    while (($line = fgets($handle)) !== false) {
                        $row = explode(";", $line);
                        $index = $row[0];
                        $value = isset($row[1]) && trim($row[1]) !== '' ? trim($row[1]) : '';
                        $data[$index] = $value;
                    }
                    fclose($handle);
                }

                $data = array(
                    "type" => "client",
                    "name" => $data["Name"],
                    "email" => isset($data["MainInvoicingContact_Email"]) && trim($data["MainInvoicingContact_Email"]) !== '' ? trim($data["MainInvoicingContact_Email"]) : 'contact@contact.Fr',
                    "website" => isset($data["MainInvoicingAddress_WebSite"]) && trim($data["MainInvoicingAddress_WebSite"]) !== '' ? trim($data["MainInvoicingAddress_WebSite"]) : 'https://bigdataconsulting.fr',
                    "phone_number" => isset($data["MainInvoicingContact_Phone"]) && trim($data["MainInvoicingContact_Phone"]) !== '' ? $this->formatPhoneNumber($data["MainInvoicingContact_Phone"]) : '+33100000000',
                    "mobile_number" => isset($data["MainInvoicingContact_CellPhone"]) && trim($data["MainInvoicingContact_CellPhone"]) !== '' ? $this->formatPhoneNumber($data["MainInvoicingContact_CellPhone"]) : '+33600000000',
                    "fax_number" => isset($data["MainInvoicingContact_Fax"]) && trim($data["MainInvoicingContact_Fax"]) !== '' ? $this->formatPhoneNumber($data["MainInvoicingContact_Fax"]) : '+33100000000',
                    "legal_france" => array(
                        "siret" => "99999999999999",
                        "siren" => isset($data["Siren"]) && trim($data["Siren"]) !== '' ? trim($data["Siren"]) : '999999999',
                        "vat" => isset($data["IntracommunityVATNumber"]) && trim($data["IntracommunityVATNumber"]) !== '' ? trim($data["IntracommunityVATNumber"]) : '999999999999999',
                        "ape_naf_code" => isset($data["NAF"]) && trim($data["NAF"]) !== '' ? trim($data["NAF"]) : '99999',
                        "company_type" =>  isset($data["Civility"]) && trim($data["Civility"]) !== '' ? trim($data["Civility"]) : '9999',
                        "rcs_immatriculation" => "999"
                    ),
                    "reference" => $data["Id"],
                    "note" => $data["Notes"],
                    "is_archived" => false
                );

                $data_string = json_encode($data);
                // print_r($data_string);
                $curl = curl_init();
                curl_setopt_array($curl, array(
                    CURLOPT_URL => $url,
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_CUSTOMREQUEST => "POST",
                    CURLOPT_POSTFIELDS => $data_string,
                    CURLOPT_HTTPHEADER => array(
                        "Content-Type: application/json",
                        "Authorization: Bearer $this->sellsy_access_token"
                    ),
                ));

                $response = curl_exec($curl);
                if ($response === false) {
                    echo "Erreur cURL : " . curl_error($curl);
                } else {
                    $response_data = json_decode($response, true);
                    $id = $response_data['id'];
                    $name = $response_data['name'];
                    $ArrayTranscoCustomersSellsy[] = array('id' => $id, 'name' => $name);
                    echo "[SUCCESS] Client : (id:".$id.") - ".$name;
                }
                curl_close($curl);
        }
        $json_string = json_encode($ArrayTranscoCustomersSellsy);
        file_put_contents($FiletranscoCustomersSellsy, $json_string);

    }

    public function formatPhoneNumber($phoneNumber) {
        $clean_phone = preg_replace("/[^0-9]/", "", $phoneNumber);
        $formatted_phone = "+33" . substr($clean_phone, -9);
        return $formatted_phone;
    }




     
    public function ImportToSellsyV1(){ 
        $url = $this->SellsyAPIAuth->GetApiPathClientsToImport();
        // $functions = new Functions();
        // $logs = new Logs();

        $this_dir = dirname(__FILE__);
        $parent_dir = realpath($this_dir . '/..');
        $import_dir = $_ENV["EDICONNECT_EBP"]."Imports/Customers/";
        // $FiletranscoCustomersSellsy = $_ENV["EDICONNECT_EBP"]."TranscoSellsy/Customers.json";
        // $ArrayTranscoCustomersSellsy = array();
        

        $files = glob("$import_dir/*.csv");        
        
        foreach($files as $filepath) {

                if (($handle = fopen($filepath, "r")) !== false) {
                    $data = array();
                    while (($line = fgets($handle)) !== false) {
                        $row = explode(";", $line);
                        $index = $row[0];
                        $value = isset($row[1]) && trim($row[1]) !== '' ? trim($row[1]) : '';
                        $data[$index] = $value;
                    }
                    fclose($handle);
                }


                $nameClient = str_replace(array('>', '"', "." ,","), '', $data["Name"]);
                $CustomerName = trim(str_replace(array('"'), '', $data["Name"]));

                $nameClient = isset($data["Name"]) ? trim($data["Name"]) : '';
                $mainInvoicingContactEmail = isset($data["MainInvoicingContact_Email"]) ? trim(str_replace(array('>', '"'), '', $data["MainInvoicingContact_Email"])) : '';
                $mainInvoicingContactPhone = isset($data["MainInvoicingContact_Phone"]) ? $this->formatPhoneNumber($data["MainInvoicingContact_Phone"]) : '';
                $mainInvoicingContactFax = isset($data["MainInvoicingContact_Fax"]) ? $this->formatPhoneNumber($data["MainInvoicingContact_Fax"]) : '';
                $mainInvoicingContactCellPhone = isset($data["MainInvoicingContact_CellPhone"]) ? $this->formatPhoneNumber($data["MainInvoicingContact_CellPhone"]) : '';
                $mainInvoicingAddressWebSite = isset($data["MainInvoicingAddress_WebSite"]) ? trim($data["MainInvoicingAddress_WebSite"]) : '';
                $mainInvoicingContactName = isset($data["MainInvoicingContact_Name"]) ? trim($data["MainInvoicingContact_Name"]) : '';
                $mainInvoicingContactFirstName = isset($data["MainInvoicingContact_FirstName"]) ? trim($data["MainInvoicingContact_FirstName"]) : '';
                $mainInvoicingAddressAddress1 = isset($data["MainInvoicingAddress_Address1"]) ? trim($data["MainInvoicingAddress_Address1"]) : '';
                $mainInvoicingAddressAddress2 = isset($data["MainInvoicingAddress_Address2"]) ? trim($data["MainInvoicingAddress_Address2"]) : '';
                $mainInvoicingAddressAddress3 = isset($data["MainInvoicingAddress_Address3"]) ? trim($data["MainInvoicingAddress_Address3"]) : '';
                $mainInvoicingAddressAddress4 = isset($data["MainInvoicingAddress_Address4"]) ? trim($data["MainInvoicingAddress_Address4"]) : '';
                $mainInvoicingAddressZipCode = isset($data["MainInvoicingAddress_ZipCode"]) ? trim($data["MainInvoicingAddress_ZipCode"]) : '';
                $mainInvoicingAddressCity = isset($data["MainInvoicingAddress_City"]) ? trim($data["MainInvoicingAddress_City"]) : '';
                $mainInvoicingAddressCountryIsoCod = isset($data["MainInvoicingAddress_CountryIsoCod"]) ? trim($data["MainInvoicingAddress_CountryIsoCod"]) : '';
                $notes = isset($data["Notes"]) ? $data["Notes"] : '';

                // $CustomerName = trim(str_replace(array('.',','), '', $CustomerName));
                $request = array(
                    'method' => 'Client.getList',
                    'params' => array(
                        'search' => array(
                            'name' => $CustomerName
                        )
                    )
                );
                
                $json = json_encode($request);
                $timestamp = time();
                $curl = curl_init();
                curl_setopt_array($curl, array(
                    CURLOPT_URL => 'https://apifeed.sellsy.com/0/',
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_ENCODING => '',
                    CURLOPT_MAXREDIRS => 999999,
                    CURLOPT_TIMEOUT => 0,
                    CURLOPT_CONNECTTIMEOUT => 1, // Set the connect timeout to 1 second
                    CURLOPT_FOLLOWLOCATION => true,
                    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                    CURLOPT_CUSTOMREQUEST => 'POST',
                    CURLOPT_POSTFIELDS => array(
                        'request' => '1',
                        'io_mode' => 'json',
                        'do_in' => $json,
                    ),
                    CURLOPT_HTTPHEADER => array(
                        'Authorization: OAuth oauth_consumer_key="ffaf35c5356a1086018fabdcdad12c9a9868daae",oauth_token="7058f93354bd475e3dda7def2defa4b50034f0d4",oauth_signature_method="PLAINTEXT",oauth_timestamp="' . $timestamp . '",oauth_nonce="EMx6bZLTZLn",oauth_version="1.0",oauth_signature="ba57cddc777f7e31174914adcea5009ac7510366%264ad049a444ab381e29773e5f9d92b119728eac95"'
                    ),
                ));
                $response = curl_exec($curl);
                $curlInfo = curl_getinfo($curl);
                curl_close($curl);

                // Decode the API response
                $data = json_decode($response, true);

                





                // Check if the API returned an error
                // if (isset($data['status']) && $data['status'] === 'success') {
                if (isset($data['response']['infos']['nbtotal']) && $data['response']['infos']['nbtotal'] > 0 && isset($data['status']) && $data['status'] === 'success') {
                    $result = $data['response']['result'];

                    // Check if the result is empty
                    if (!empty($result)) {
                        // Get the first item from the result
                        $item = reset($result);
                        $itemId = key($result);
                        $addr_part1 = $item['addr_part1'];
                        $addr_zip = $item['addr_zip'];
                        $addr_town = $item['addr_town'];

                        $contacts = $item['contacts'];
                        $firstContact = reset($contacts);
                        $name = $firstContact['name'];
                        $forename = $firstContact['forename'];
                        $tel = $firstContact['tel'];
                        $email = $firstContact['email'];
                        // echo $itemId."-".$CustomerName."-".$email."-".$tel."-".$name."-".$forename."-".$addr_part1."-".$addr_zip."-".$addr_town."<br>";
                        $qr = new Queries();
                        $result = $qr->TranscoCustomers($itemId,$CustomerName,$email,$tel,$name,$forename,$addr_part1,$addr_zip,$addr_town);
                        if ($result == "inserted") {
                            rename($filepath, $import_dir.'/SuccessDelta/customer_'.$nameClient.'.csv');
                        }
                        echo "[SUCCESS] Client : (id:".$itemId.") - ".$CustomerName.' - '.$email.'-'.$tel.'-'.$name.'-'.$forename.'<br>';
                    }
                } else {
                                                        
                    
                    
                                                    $request = array(
                                                        'method' => 'Client.create',
                                                        'params' => array(
                                                            'third' => array(
                                                                'name' => $nameClient,
                                                                'type' => "corporation",
                                                                'email' => $mainInvoicingContactEmail !== '' ? $mainInvoicingContactEmail : '',
                                                                'tel' => $mainInvoicingContactPhone !== '' ? $mainInvoicingContactPhone : '',
                                                                'fax' => $mainInvoicingContactFax !== '' ? $mainInvoicingContactFax : '',
                                                                'mobile' => $mainInvoicingContactCellPhone !== '' ? $mainInvoicingContactCellPhone : '',
                                                                'web' => $mainInvoicingAddressWebSite !== '' ? $mainInvoicingAddressWebSite : '',
                                                                'stickyNote' => $notes,
                                                            ),
                                                            'contact' => $mainInvoicingContactName !== '' ? array(
                                                                'name' => $mainInvoicingContactName !== '' ? $mainInvoicingContactName : '',
                                                                'forename' => $mainInvoicingContactFirstName !== '' ? $mainInvoicingContactFirstName : '',
                                                                'email' => $mainInvoicingContactEmail !== '' ? $mainInvoicingContactEmail : '',
                                                                'tel' => $mainInvoicingContactPhone !== '' ? $mainInvoicingContactPhone : '',
                                                                'fax' => $mainInvoicingContactFax !== '' ? $mainInvoicingContactFax : '',
                                                                'mobile' => $mainInvoicingContactCellPhone !== '' ? $mainInvoicingContactCellPhone : '',
                                                                'web' => $mainInvoicingAddressWebSite !== '' ? $mainInvoicingAddressWebSite : '',
                                                            ) : '',
                                                            'address' => array(
                                                                'name' => "Adresse de facturation",
                                                                'part1' => $mainInvoicingAddressAddress1 !== '' ? $mainInvoicingAddressAddress1 : '',
                                                                'part2' => $mainInvoicingAddressAddress2 !== '' ? $mainInvoicingAddressAddress2 : '',
                                                                'part3' => $mainInvoicingAddressAddress3 !== '' ? $mainInvoicingAddressAddress3 : '',
                                                                'part4' => $mainInvoicingAddressAddress4 !== '' ? $mainInvoicingAddressAddress4 : '',
                                                                'zip' => $mainInvoicingAddressZipCode !== '' ? $mainInvoicingAddressZipCode : '',
                                                                'town' => $mainInvoicingAddressCity !== '' ? $mainInvoicingAddressCity : '',
                                                                'countrycode' => $mainInvoicingAddressCountryIsoCod !== '' ? $mainInvoicingAddressCountryIsoCod : '',
                                                            )
                                                        )
                                                    );

                                                    
                                                    $json = json_encode($request);
                                                    $timestamp = time();
                                                    $curl = curl_init();
                                                    curl_setopt_array($curl, array(
                                                        CURLOPT_URL => 'https://apifeed.sellsy.com/0/',
                                                        CURLOPT_RETURNTRANSFER => true,
                                                        CURLOPT_ENCODING => '',
                                                        CURLOPT_MAXREDIRS => 999999,
                                                        CURLOPT_TIMEOUT => 0,
                                                        CURLOPT_FOLLOWLOCATION => true,
                                                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                                                        CURLOPT_CUSTOMREQUEST => 'POST',
                                                        CURLOPT_POSTFIELDS => array(
                                                            'request' => '1',
                                                            'io_mode' => 'json',
                                                            'do_in' => $json,
                                                        ),
                                                        CURLOPT_HTTPHEADER => array(
                                                            'Authorization: OAuth oauth_consumer_key="ffaf35c5356a1086018fabdcdad12c9a9868daae",oauth_token="7058f93354bd475e3dda7def2defa4b50034f0d4",oauth_signature_method="PLAINTEXT",oauth_timestamp="' . $timestamp . '",oauth_nonce="EMx6bZLTZLn",oauth_version="1.0",oauth_signature="ba57cddc777f7e31174914adcea5009ac7510366%264ad049a444ab381e29773e5f9d92b119728eac95"'
                                                        ),
                                                    ));
                                                    $response = curl_exec($curl);
                                                    if(json_decode($response)->status == "success"){
                                                        $id = json_decode($response)->response->client_id;
                                                        $name = $nameClient;

                                                        $mail = trim(str_replace(array('>', '"',"'"), '', $mainInvoicingContactEmail));
                                                        $tel = $this->formatPhoneNumber($mainInvoicingContactPhone);
                                                        $contactname = trim(str_replace(array('>', '"',"'"), '', $mainInvoicingContactName));
                                                        $contactforename = trim(str_replace(array('>', '"',"'"), '', $mainInvoicingContactFirstName));


                                                        $Address1 = trim(str_replace(array('"'), '', $mainInvoicingAddressAddress1));
                                                        $ZipCode = trim(str_replace(array('"'), '', $mainInvoicingAddressZipCode));
                                                        $City = trim(str_replace(array('"'), '', $mainInvoicingAddressCity));


                                                        // $ArrayTranscoCustomersSellsy[] = array('id' => $id, 'name' => $name);
                                                        echo "[SUCCESS] Client : (id:".$id.") - ".$name.' - '.$mail.'-'.$tel.'-'.$contactname.'-'.$contactforename;
                                                        $queries = new Queries();
                                                        $result = $queries->TranscoCustomers($id,$name,$mail,$tel,$contactname,$contactforename,$Address1,$ZipCode,$City);
                                                        if ($result) {
                                                            echo 'Transco : '.$result;
                                                        }
                                                        echo '<br>';


                                                        rename($filepath, $import_dir.'/SuccessDelta/customer_'.$nameClient.'.csv');
                                                    }else{
                                                        // print_r(json_decode($response));
                                                        $response = json_decode($response); // Convert the response to stdClass object
                                                        $errorMessage = $response->error->message;
                                                        echo $nameClient.' : '.$errorMessage;
                                                    
                                                        echo '<br><br>';
                                                        rename($filepath, $import_dir.'/Errors/customer_'.$nameClient.'.csv');
                                                    }
                                                    curl_close($curl);
                                                    sleep(4);
                }
                

                                                    

        }
        // $json_string = json_encode($ArrayTranscoCustomersSellsy);
        // file_put_contents($FiletranscoCustomersSellsy, $json_string);
        
    }



    // public function CleanDoublonCustomers(){
    //     $queries = new Queries();
    //     $duplicates = $queries->CheckDuplicated();
    //     if ($duplicates) {
    //         foreach ($duplicates as $duplicateIdsellsy) {
    //             $idsellsyArray = explode(',', $duplicateIdsellsy);
    //             array_shift($idsellsyArray); 
    //             foreach ($idsellsyArray as $clientid) {
    //                 echo $clientid."<br>";
    //                 $request = array(
    //                     'method' => 'Client.getOne', 
    //                     'params' => array(
    //                         'clientid' => $clientid
    //                     )
    //                 );
    //             $json = json_encode($request);
    //             $timestamp = time();
    //             $curl = curl_init();
    //             curl_setopt_array($curl, array(
    //                 CURLOPT_URL => 'https://apifeed.sellsy.com/0/',
    //                 CURLOPT_RETURNTRANSFER => true,
    //                 CURLOPT_ENCODING => '',
    //                 CURLOPT_MAXREDIRS => 999999,
    //                 CURLOPT_TIMEOUT => 0,
    //                 CURLOPT_FOLLOWLOCATION => true,
    //                 CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    //                 CURLOPT_CUSTOMREQUEST => 'POST',
    //                 CURLOPT_POSTFIELDS => array(
    //                     'request' => '1',
    //                     'io_mode' => 'json',
    //                     'do_in' => $json,
    //                 ),
    //                 CURLOPT_HTTPHEADER => array(
    //                     'Authorization: OAuth oauth_consumer_key="ffaf35c5356a1086018fabdcdad12c9a9868daae",oauth_token="7058f93354bd475e3dda7def2defa4b50034f0d4",oauth_signature_method="PLAINTEXT",oauth_timestamp="' . $timestamp . '",oauth_nonce="EMx6bZLTZLn",oauth_version="1.0",oauth_signature="ba57cddc777f7e31174914adcea5009ac7510366%264ad049a444ab381e29773e5f9d92b119728eac95"'
    //                 ),
    //             ));
    //             $response = curl_exec($curl);

    //             $resp = json_decode($response, true);
    //             echo curl_getinfo($curl, CURLINFO_HTTP_CODE);
    //             if($resp){
    //                 $contactid = array_keys($resp['response']['contacts'])[0];
    //                 echo "[SUCCESS] : Client ($clientid) and contact($contactid)<br>";

    //             }
    //             }
    //         }
    // }

    public function checkCustomers()
{
    $queries = new Queries();
    $customers = $queries->getCustomers();

    if ($customers) {
        foreach ($customers as $clientId) {
            $request = array(
                'method' => 'Client.getOne',
                'params' => array(
                    'clientid' => $clientId
                )
            );
            $json = json_encode($request);
            $timestamp = time();
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => 'https://apifeed.sellsy.com/0/',
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 999999,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_CONNECTTIMEOUT => 1, // Set the connect timeout to 1 second
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS => array(
                    'request' => '1',
                    'io_mode' => 'json',
                    'do_in' => $json,
                ),
                CURLOPT_HTTPHEADER => array(
                    'Authorization: OAuth oauth_consumer_key="ffaf35c5356a1086018fabdcdad12c9a9868daae",oauth_token="7058f93354bd475e3dda7def2defa4b50034f0d4",oauth_signature_method="PLAINTEXT",oauth_timestamp="' . $timestamp . '",oauth_nonce="EMx6bZLTZLn",oauth_version="1.0",oauth_signature="ba57cddc777f7e31174914adcea5009ac7510366%264ad049a444ab381e29773e5f9d92b119728eac95"'
                ),
            ));
            $response = curl_exec($curl);
            $curlInfo = curl_getinfo($curl);
            curl_close($curl);

            // Check if the request finished successfully
                $resp = json_decode($response, true);

                if ($resp) {
                    $address = $resp['response']['address'];

                    $adr = reset($address); // Get the first contact
                    $adrs1 = $adr['part1'];
                    $zip = $adr['zip'];
                    $city = $adr['town'];


                    $Updatequeries = new Queries();
                    // $Updatecustomers = $queries->UpdateCustomers($email,$formattedTel,$contactname,$contactforename,$clientId);
                    $Updatecustomers = $queries->UpdateCustomersAdr($adrs1,$zip,$city,$clientId);
                    if ($Updatecustomers) {
                        // echo "[UPDATED] client($clientId) and forename($forename) and name($name) and email($email) and formatted_tel($formattedTel)<br>";
                        echo $Updatecustomers;
                    }
                    echo '<br>';
                }
                sleep(1);
            
        }
    }
}




public function deleteDuplicatedCustomers()
{
    $queries = new Queries();
    $customers = $queries->getCustomerstoDelete();

    if ($customers) {
        foreach ($customers as $clientId) {
            $request = array(
                'method' => 'Client.delete',
                'params' => array(
                    'clientid' => $clientId
                )
            );
            $json = json_encode($request);
            $timestamp = time();
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => 'https://apifeed.sellsy.com/0/',
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 999999,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_CONNECTTIMEOUT => 1, // Set the connect timeout to 1 second
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS => array(
                    'request' => '1',
                    'io_mode' => 'json',
                    'do_in' => $json,
                ),
                CURLOPT_HTTPHEADER => array(
                    'Authorization: OAuth oauth_consumer_key="ffaf35c5356a1086018fabdcdad12c9a9868daae",oauth_token="7058f93354bd475e3dda7def2defa4b50034f0d4",oauth_signature_method="PLAINTEXT",oauth_timestamp="' . $timestamp . '",oauth_nonce="EMx6bZLTZLn",oauth_version="1.0",oauth_signature="ba57cddc777f7e31174914adcea5009ac7510366%264ad049a444ab381e29773e5f9d92b119728eac95"'
                ),
            ));
            $response = curl_exec($curl);
            $curlInfo = curl_getinfo($curl);
            curl_close($curl);

            // Check if the request finished successfully
                $resp = json_decode($response, true);

                if ($resp['status'] === 'success') {

                    echo 'Customer : '.$clientId.' Deleted<br>';
                }else{
                    echo 'Customer : '.$clientId.' Already Deleted<br>';

                }
                sleep(1);
            
        }
    }
}


}
?>


