<?php
class DESADVController
{
    public function Export(){
        print '------------------<br>Export Desadv :<br>';
        include_once("Configurations/api.php");
        $APIAuth = new APIAuth();
        $curl = curl_init($APIAuth->GetApiPathDesadvExport());
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "GET");
        curl_setopt($curl, CURLOPT_URL, $APIAuth->GetApiPathDesadvExport());
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPHEADER, $APIAuth->GetAuthHeader());
        $resp = curl_exec($curl);
        $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        if($http_code == "200"){ 
            include("Models/DESADVModel.php");
            $DesadvModel = new DESADVModel();
            $result = json_decode($resp,true);
            $DesadvModel->Export($result);
        }else{ 
            echo "Error : ".$http_code." <br> Please check you access TOKEN KEY's to the API.";
        }
        curl_close($curl);
    } 
    
    public function Import(){      
        
        include_once("Functions/Logs.php");
        include_once("Functions/Functions.php");
        include_once("Configurations/api.php");
        $APIAuth = new APIAuth();
        $url = $APIAuth->GetApiPathDesadvImport();
        $access_token = $APIAuth->access_token;    
        $ebp_subscription_key = $APIAuth->ebp_subscription_key;
        $functions = new Functions($access_token, $ebp_subscription_key);
        $logs = new Logs();

        $this_dir = dirname(__FILE__);
        $parent_dir = realpath($this_dir . '/..');
        $import_dir = "Imports/Desadv";
        $files = glob("$import_dir/*.csv");

        foreach($files as $filepath) {
            if ($handle = fopen($filepath, "r")) {
                $first_line_data = fgetcsv($handle,1000,",");
                $desadv_ref = $first_line_data[0];

                $replace_fields_result = $functions->replace_fields($filepath, $desadv_ref);

                $curl = curl_init();
                curl_setopt_array($curl, array(
                CURLOPT_URL => $url,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS => array('file'=> new CURLFILE($filepath)),
                CURLOPT_HTTPHEADER => array(
                        "ebp-subscription-key: $ebp_subscription_key",
                        "Authorization: Bearer $access_token"
                    ),
                ));

                $response = curl_exec($curl);
                $response = json_decode($response);

                if ($importId = $response->importId) {
                    do {
                        $importInfo = $functions->getImportInfo($importId, $access_token, $ebp_subscription_key);
                    } while ($importInfo->status === "Starting" || $importInfo->status === "Waiting");

                    $date = date("YmdHis");
                    $nb_errors = $importInfo->importInfos->itemError;

                    if ($importInfo->status === "Completed") {
                        if ($nb_errors == 0) {
                            $target_path = $parent_dir . "/Logs/Desadv/Imports/SUCCESS_DESADV_$desadv_ref" . "_$date.txt";
                            $file = fopen($target_path, "a") or die("Unable to open file!");
                            $logs->writeImportLog($file, $importInfo, "success");
                        }else {
                            $target_path = $parent_dir . "/Logs/Desadv/Imports/ERROR_DESADV_$desadv_ref" . "_$date.txt";
                            $file = fopen($target_path, "a") or die("Unable to open file!");
                            $logs->writeImportLog($file, $importInfo, "error");
                        }
                    }

                }
                curl_close($curl);
            }
            fclose($filepath);
        }
    } 
}
?>
