<?php

include_once($_ENV["EDICONNECT_EBP"]."Configurations/api.php");
include_once($_ENV["EDICONNECT_EBP"]."Configurations/api_sellsy.php");
include_once($_ENV["EDICONNECT_EBP"]."Class/queries.class.php");

class DevisController
{
    public function __construct(){
        $this->APIAuth = new APIAuth();
        $this->SellsyAPIAuth = new SellsyAPIAuth();

        $this->access_token = $this->APIAuth->access_token;
        $this->refresh_token =  $this->APIAuth->refresh_token;

        $this->ebp_subscription_key = $this->APIAuth->ebp_subscription_key;
        $this->sellsy_access_token = $this->SellsyAPIAuth->access_token;

    }


    public function exportAll(){
        print '------------------<br>Export All Devis :<br>';
        include_once($_ENV["EDICONNECT_EBP"]."Models/DevisModel.php");
        $DevisModel = new DevisModel();

        include_once($_ENV["EDICONNECT_EBP"]."Functions/Logs.php");

        $logs = new Logs();

        $offset = 21739;
        // $offset = 20700;
        // $offset = 2550;
        // $offset = 10350;
        // $offset = 15651;
        $devis = [];
        // $url = $this->APIAuth->getApiPathAllDevisExport($offset);
        // $curl = curl_init();

        
        // curl_setopt_array($curl, array(
        //     CURLOPT_URL => $url,
        //     CURLOPT_RETURNTRANSFER => true,
        //     CURLOPT_ENCODING => "",
        //     CURLOPT_MAXREDIRS => 10,
        //     CURLOPT_TIMEOUT => 0,
        //     CURLOPT_FOLLOWLOCATION => true,
        //     CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        //     CURLOPT_CUSTOMREQUEST => "GET",
        //     CURLOPT_HTTPHEADER => array(
        //         "ebp-subscription-key: $this->ebp_subscription_key",
        //         "Authorization: Bearer $this->access_token"
        //     ),
        // ));

        // $resp = json_decode(curl_exec($curl),true);
        // $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        // curl_close($curl);

        // if ($http_code == "200") {
        //     $devis = array_merge($devis, $resp["results"]);
        // }else{ 
        //     echo "Error : ".$http_code." <br> Please check your access TOKEN KEY's to the API.";

        //     $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Products/Deletes/Errors/ERROR_PRODUCT_$date.txt";
        //     $file = fopen($error_path, "a");
        //     $logs->addLog($file, "SUPPRESSION PRODUIT", "Erreur avec la requete cURL lors de l'export de produits (Erreur $http_code)", "ERROR");
        // }       
        
        $is_export_done = false;

        try {
            // do {
                $url = $this->APIAuth->getApiPathAllDevisExport($offset);
                $curl = curl_init();
    
                // if ($offset > 28000) {
                //     die("die");
                // }
                curl_setopt_array($curl, array(
                    CURLOPT_URL => $url,
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_ENCODING => "",
                    CURLOPT_MAXREDIRS => 10,
                    CURLOPT_TIMEOUT => 0,
                    CURLOPT_FOLLOWLOCATION => true,
                    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                    CURLOPT_CUSTOMREQUEST => "GET",
                    CURLOPT_HTTPHEADER => array(
                        "ebp-subscription-key: $this->ebp_subscription_key",
                        "Authorization: Bearer $this->access_token"
                    ),
                ));
        
                $resp = json_decode(curl_exec($curl),true);
                $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
                curl_close($curl);
    
                if ($http_code == "200") {
                    $devis = $resp["results"];
                    
                    if(count($devis) > 0){ 
                        // $DevisModel->exportAll($devis);
                        $DevisModel->export($devis);
                    }else{ 
                        echo "<br>No devis to export<br>";
                    }
    
                    $offset += 100;
                            
                    // if ($resp["paging"]["total"] == 0) {
                    //     $is_export_done = true;
                    // }
                }else{ 
                    echo "Error : ".$http_code." <br> Please check your access TOKEN KEY's to the API.";
        
                    $tokens = $this->APIAuth->getAccessTokenFromRefreshToken($this->refresh_token);
                    $this->access_token = $tokens["access_token"];
                    $this->refresh_token = $tokens["refresh_token"];
    
                    $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Devis/Errors/ERROR_DEVIS_$date.txt";
                    $file = fopen($target_path, "a");
                    $logs->addLog($file, "EXPORT DEVIS", "Erreur avec la requete cURL lors de l'export de devis (Erreur $http_code)", "ERROR");
                }
    
            // } while ($is_export_done == false);

        } catch (\Throwable $th) {
            //throw $th;
            echo '<pre>';
            var_dump($th);
            echo '</pre>';
        }
    } 


       
      
    public function ImportToSellsy(){ 


        $url = $this->SellsyAPIAuth->GetApiPathDevisToImport();
        
        // $functions = new Functions();
        // $logs = new Logs();
        
        $this_dir = dirname(__FILE__);
        $parent_dir = realpath($this_dir . '/..');
        $import_dir = $_ENV["EDICONNECT_EBP"]."Imports/Devis";
        $FiletranscoCustomersSellsy = $_ENV["EDICONNECT_EBP"]."TranscoSellsy/Customers2.json";
        $files = glob("$import_dir/*.csv");        
        
        $json_string = file_get_contents($FiletranscoCustomersSellsy);
        $data = json_decode($json_string, true);
        // print_r($data);
        $shippingAmountVatExcluded = 0;

        foreach($files as $filepath) {
                $rowsLines = array();
                if (($handle = fopen($filepath, "r")) !== false) {
                    while (($line = fgetcsv($handle, 0, ';')) !== FALSE) {
                        if ($line[0] == 'DEVIS-HD1') {
                            $DocumentNumber = $line[3];
                            $DocumentDate = $line[5];
                            $DeliveryDate = $line[6];
                            $DeliveryAddress_Address1 = $line[7];
                            $DeliveryAddress_Address2 = $line[8];
                            $DeliveryAddress_Address3 = $line[9];
                            $DeliveryAddress_ZipCode = $line[10];
                            $DeliveryAddress_City = $line[11];
                        }
                        if ($line[0] == 'DEVIS-HD2') {
                            $CustomerName = str_replace('"', '', $line[1]);
                            $DeliveryAddress_WebSite = $line[2];
                            $InvoicingAddress_Address1 = $line[3];
                            $InvoicingAddress_Address2 = $line[4];
                            $InvoicingAddress_Address3 = $line[5];
                            $InvoicingAddress_ZipCode = $line[6];
                            $InvoicingAddress_City = $line[7];
                        }
                        if ($line[0] == 'DEVIS-HD3') {
                            $DeliveryContact_Name = $line[1];
                            $DeliveryContact_FirstName = $line[2];
                            $DeliveryContact_Phone = $line[3];
                            $DeliveryContact_CellPhone = $line[4];
                            $DeliveryContact_Fax = $line[5];
                            $DeliveryContact_Email = $line[6];
                        }
                        if ($line[0] == 'DEVIS-TAX') {
                            $taxValue = $line[1];
                            $vatAmount = $line[2];
                            $detailVatAmount0_EcotaxAmountVatExcluded = $line[3];
                            $detailVatAmount0_EcotaxVatAmount = $line[4];
                            $tva_tx_0 = $line[5];
                            $tva_base_ht_0 = $line[6];
                            $tva_montant_tva_0 = $line[7];
                            $tva_tx_1 = $line[8];
                            $tva_base_ht_1 = $line[9];
                            $tva_montant_tva_1 = $line[10];
                            $tva_tx_2 = $line[11];
                            $tva_base_ht_2 = $line[12];
                            $tva_montant_tva_2 = $line[13];
                            $tva_tx_3 = $line[14];
                            $tva_base_ht_3 = $line[15];
                            $tva_montant_tva_3 = $line[16];
                            $tva_tx_4 = $line[17];
                            $tva_base_ht_4 = $line[18];
                            $tva_montant_tva_4 = $line[19];
                            $tva_tx_5 = $line[20];
                            $tva_base_ht_5 = $line[21];
                            $tva_montant_tva_5 = $line[22];
                        }
                        if ($line[0] == 'DEVIS-END') {
                            $amountHT = $line[2];
                            $amountTTC = $line[3];
                            $costPrice = $line[4];
                            $amountVatExcludedWithDiscountAndShipping = $line[5];
                            $shippingAmountVatExcluded = $line[6];    
                        }

                        
                        if ($line[0] == 'DEVIS-LIN') {
                            if(!empty($line[4]) || !(empty($line[5]))){
                                $total_ht = floatval($line[7]);
                                $qty = floatval($line[10]);
                                $pu_ht = floatval($total_ht / $qty);

                                $vatPercentage = ($line[15] / $line[7]) * 100;
                                
                                switch ($vatPercentage) {
                                    case 20:
                                        $vatid = 3884771;
                                        break;
                                    case 10:
                                        $vatid = 3884772;
                                        break;
                                    case 8.5:
                                        $vatid = 3884773;
                                        break;
                                    case 5.5:
                                        $vatid = 3884774;
                                        break;
                                    case 2.1:
                                        $vatid = 3884775;
                                        break;
                                    case 0:
                                        $vatid = 3884776;
                                        break;
                                    default:
                                        $vatid = 3884776;
                                        break;
                                }
                                
                                if(($line[4] == "PORT") && ($line[16]>0)){
                                    $rowsLines[] = array(
                                        "type" => "shipping",
                                        "quantity" => $line[10],
                                        "tax_id" => $vatid,
                                        "reference" => "Frais de port",
                                        "description" => null,
                                        "discount" =>  null,
                                        "tax_rate"=> "20.00",
                                        "amount_tax_exc"=> strval($line[16]),
                                        "analytic_code"=> null,
                                        "unit_amount"=> strval($line[16]),
                                        "tax_label"=> "",
                                        "related"=> array(
                                            "type"=> "shipping",
                                            "id"=> 9289377
                                        )
                                    );
                                }else{

                                    
                                    if (is_nan($vatPercentage)) {
                                        $row_unitAmount=0;
                                    } else {
                                        $row_unitAmount = $vatPercentage;
                                    }

                                    if (is_nan($pu_ht)) {
                                        $pu_ht=0;
                                    }

                                    $rowsLines[] = array(
                                        "type" => "single",
                                        "quantity" => $line[10],
                                        "tax_id" => $vatid,
                                        "reference" => $line[4],
                                        "description" => $line[5],
                                        "discount" =>  array(
                                            "value" => $pu_ht < 0 ? strval(abs($pu_ht)) : '0',
                                            "type" => "amount",
                                        ),
                                        "tax_rate" => strval(round($row_unitAmount, 2)), //strval($line[16]),
                                        "tax_amount" => $line[15],
                                        "amount_tax_inc" => $line[8],
                                        "amount_tax_exc" => $line[7],
                                        "analytic_code" => null,
                                        "purchase_amount" => $line[13],
                                        "unit_amount" => $pu_ht > 0 ? strval($pu_ht) : '0',
                                        "tax_label" => ""
                                    );
                                }

                                
                            }
                        }
                    }
                    
                    
                    // foreach ($data as $item) {
                        // if($item['name'] == $CustomerName){
                        $getCustomerqueries = new Queries();

                        $CustomerName = trim(str_replace(array('"'), '', $CustomerName));
                        $Address1 = trim(str_replace(array('"'), '', $InvoicingAddress_Address1));
                        $ZipCode = trim(str_replace(array('"'), '', $InvoicingAddress_ZipCode));
                        $City = trim(str_replace(array('"'), '', $InvoicingAddress_City));
                        $DeliveryContact_Phone = trim(str_replace(array('"'), '', $DeliveryContact_Phone));


                        // $getCustomer = $getCustomerqueries->getDocumentCustomer($CustomerName,$Address1,$ZipCode,$City,$DeliveryContact_Email,$DeliveryContact_Name,$DeliveryContact_Phone,$DeliveryContact_FirstName);
                        $getCustomer = $getCustomerqueries->getCustomerID($CustomerName);

                        // $getCustomer = $getCustomerqueries->getDocumentCustomer($CustomerName,$DeliveryContact_Email,$DeliveryContact_Name);
                        
                        if ($getCustomer !== false) {
                            // echo $getCustomer."<br>";

                            $DocumentDate = new DateTime($DocumentDate);
                            $data_line = array(
                                    "date" => $DocumentDate->format('Y-m-d'),
                                    "related" => array(
                                        array(
                                            "type" => "company",
                                            "id" => (int) $getCustomer
                                        )
                                    ),
                                    "status" => "read",
                                    "number" => $DocumentNumber,
                                    "amounts" => array(
                                        "shipping" => "15.00",
                                        "packaging" => "0.00",
                                        "total_raw_excl_tax" => $amountHT,
                                        "total_after_discount_excl_tax" => $amountHT,
                                        "total_excl_tax" => $amountHT,
                                        "total" => $amountTTC
                                    ),
                                    "subject" => "",
                                    "public_link" => "string",
                                    "public_link_enabled" => false,
                                    "decimal_number" => array(
                                        "unit_price" => 2,
                                        "quantity" => 2,
                                        "main" => 2
                                    ),
                                    "payment_conditions_acceptance" => array(
                                        "enabled" => false
                                    ),
                                    "rows" => $rowsLines,
                                    "_embed" => array(
                                        "payment_terms" => array(
                                            "settings" => array(
                                                "type" => "settings",
                                                "value" => array(
                                                    "id" => 0,
                                                    "label" => "Deadlines",
                                                    "x_days" => 0,
                                                    "end_of_month" => true,
                                                    "override_date" => true
                                                )
                                            ),
                                            "computed_instalment_plan" => array(
                                                array(
                                                    "date" => $DocumentDate->format('Y-m-d'),
                                                    "amount" => "string"
                                                )
                                            )
                                        ),
                                        "currency" => array(
                                            "id" => 1,
                                            "code" => "EUR",
                                            "symbol" => "€",
                                            "is_default" => true
                                        ),
                                        "acl" => array(
                                            "can_be_updated" => true,
                                            "can_be_deleted" => true
                                        )
                                    )
                            );
                            $datastring = json_encode($data_line);
                            // print_r($datastring);
                            
                                $curl = curl_init();
                                curl_setopt_array($curl, array(
                                    CURLOPT_URL => $url,
                                    CURLOPT_RETURNTRANSFER => true,
                                    CURLOPT_CUSTOMREQUEST => "POST",
                                    CURLOPT_POSTFIELDS => $datastring,
                                    CURLOPT_HTTPHEADER => array(
                                        "Content-Type: application/json",
                                        "Authorization: Bearer $this->sellsy_access_token"
                                    ),
                                ));
        
                                $response = curl_exec($curl);
                                // print_r($response);
                                $response_data = json_decode($response, true);
                                if(isset($response_data['id'])){
                                    $id = $response_data['id'];
                                    $number = $response_data['number'];
                                    echo "[SUCCESS] Devis : (id:".$id.") - ".$number.'<br>';
                                    rename($filepath, $import_dir.'/SuccessDelta/Devis_'.$DocumentNumber.'.csv');
                                    continue;
                                }else{
                                    echo "[ERROR] Devis : (Documentnumber) - ".$DocumentNumber.'<br>';
                                    print_r($response);
                                    rename($filepath, $import_dir.'/Error/Devis_'.$DocumentNumber.'.csv');
                                    continue;
                                }
                                curl_close($curl);
                                sleep(4);
                            }else{
                                echo "<br>[ERROR] Customer not found : (DocumentNumber:".$DocumentNumber.")-".$CustomerName."-".$DeliveryContact_Email."-".$DeliveryContact_Name."!";
                                rename($filepath, $import_dir.'/NotFound/Devis_'.$DocumentNumber.'.csv');
                            }
                        // }
                    // }
        
                      
                    fclose($file);;
                }
        }
        }
        

}
?>