<?php
include_once($_ENV["EDICONNECT_EBP"]."Functions/Logs.php");
include_once($_ENV["EDICONNECT_EBP"]."Functions/Functions.php");
include_once($_ENV["EDICONNECT_EBP"]."Configurations/api.php");

class OrdersController
{
        
    public function __construct(){
 
        $this->APIAuth = new APIAuth();

        $this->access_token = $this->APIAuth->access_token;
        $this->ebp_subscription_key = $this->APIAuth->ebp_subscription_key;
    }

    public function Export(){
        echo '------------------<br>Export Orders :<br>';

        $curl = curl_init($this->APIAuth->GetApiPathOrdersExport());

        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "GET");
        curl_setopt($curl, CURLOPT_URL, $this->APIAuth->GetApiPathOrdersExport());
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPHEADER, $this->APIAuth->GetAuthHeader());

        $resp = curl_exec($curl);

        $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        if($http_code == "200"){ 
            include("Models/OrdersModel.php");
            $OrderModel = new OrderModel();
            $result = json_decode($resp,true);
            $OrderModel->Export($result);
        }else{ 
            echo "Error : ".$http_code." <br> Please check your access TOKEN KEY's to the API.";
        }
        curl_close($curl);
    } 


    public function Import(){      
        $logs = new Logs();

        try {
            $url = $this->APIAuth->GetApiPathOrderImport();

            $access_token = $this->APIAuth->access_token;    
            $ebp_subscription_key = $this->APIAuth->ebp_subscription_key;
            $header = $this->APIAuth->GetAuthHeader();
    
            $functions = new Functions();
    
            $this_dir = dirname(__FILE__);
            $parent_dir = realpath($this_dir . '/..');
            $import_dir = $_ENV["EDICONNECT_EBP"]."Imports/Orders/";
            $files = glob("$import_dir*.csv");
    
            foreach($files as $filepath) {
    
                if ($handle = fopen($filepath, "r")) 
                {
                    $first_line_data = fgetcsv($handle,1000,",");
                    $order_ref = $first_line_data[0];
                    $date = date("YmdHis");
    
                    $isCustomerExist = $functions->checkIfCustomerExist($filepath, $order_ref);
    
                    $isOrderAlreadyExist = $this->checkIfOrderExist($order_ref);
    
    
                    if ($isOrderAlreadyExist["paging"]["total"] == 0) {
                        # code...
                        if ($isCustomerExist) {
                            $curl = curl_init();
                            curl_setopt_array($curl, array(
                            CURLOPT_URL => $url,
                            CURLOPT_RETURNTRANSFER => true,
                            CURLOPT_ENCODING => '',
                            CURLOPT_MAXREDIRS => 10,
                            CURLOPT_TIMEOUT => 0,
                            CURLOPT_FOLLOWLOCATION => true,
                            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                            CURLOPT_CUSTOMREQUEST => 'POST',
                            CURLOPT_POSTFIELDS => array('file'=> new CURLFILE($filepath)),
                            CURLOPT_HTTPHEADER => $header,
                            ));
            
                            $response = curl_exec($curl);
                            $response = json_decode($response);
            
         
                            if ($importId = $response->importId) {
                                do {
                                    $importInfo = $functions->getImportInfo($importId, $access_token, $ebp_subscription_key);
                                } while ($importInfo->status === "Starting" || $importInfo->status === "Waiting");
            
                                $nb_errors = $importInfo->importInfos->itemError;
    
                                if ($importInfo->status === "Completed") {
                                    if ($nb_errors == 0) {
                                        unlink($filepath);
                                        $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Orders/Imports/SUCCESS_ORDER_$order_ref" . "_$date.txt";
                                        $file = fopen($target_path, "a");
                                        $logs->writeImportLog($file, $importInfo, "success");
    
                                        $target_path = $_ENV["EDICONNECT_EBP"]."Logs/";
                                        $logs->logRepport($target_path, "La commande $order_ref a été importée avec succès.");
                                    }else {
                                        rename($filepath, $import_dir ."Errors/". end(explode("/", $filepath)));
                                        $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Orders/Imports/Errors/ERROR_ORDER_$order_ref" . "_$date.txt";
                                        $file = fopen($target_path, "a");
                                        $logs->writeImportLog($file, $importInfo, "error");
    
                                        $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Errors";
                                        $details = $importInfo->importInfos->details;
                                        $message = $this->getImportErrorsMessage($details);

                                        $logs->logError($target_path, $message);
                                    }
                                }elseif ($importInfo->status === "OperationError") {
                                    if ($nb_errors >= 0) {
                                        rename($filepath, $import_dir ."Errors/". end(explode("/", $filepath)));
                                        $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Orders/Imports/Errors/ERROR_ORDER_$order_ref" . "_$date.txt";
                                        $file = fopen($target_path, "a");
                                        $logs->writeImportLog($file, $importInfo, "error");
    
                                        $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Errors";
                                        $details = $importInfo->importInfos->details;
                                        $message = $this->getImportErrorsMessage($details);

                                        $logs->logError($target_path, $message);
                                    }
                                }
                            }
                            curl_close($curl);
                        }else{
                            rename($filepath, $import_dir ."Errors/". end(explode("/", $filepath)));
                            $message = "Le client de la commande $order_ref n'existe pas sur la base d'EBP";
    
                            $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Errors";
                            $logs->logError($target_path, $message);
    
                            $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Orders/Imports/Errors/ERROR_ORDER_$order_ref" . "_$date.txt";
                            $file = fopen($target_path, "a");
                            $logs->addLog($file, "IMPORT COMMANDE", $message, "ERROR");
                        }
                    }else {
                        rename($filepath, $import_dir ."Errors/". end(explode("/", $filepath)));

                        $ebp_ref = $isOrderAlreadyExist["results"][0]["DocumentNumber"];
                        $message = "La commande $order_ref existe déjà sur la base d'EBP sous la référence $ebp_ref";
    
                        $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Errors";
                        $logs->logError($target_path, $message);
    
                        $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Orders/Imports/Errors/ERROR_ORDER_$order_ref" . "_$date.txt";
                        $file = fopen($target_path, "a");
                        $logs->addLog($file, "IMPORT COMMANDE", $message, "ERROR");
                    }
    
                }
                fclose($filepath);
            }
        } catch (\Throwable $th) {
            //throw $th;
            $date = date("YmdHis");

            $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Orders/Imports/Errors/ERROR_ORDER_$date.txt";
            $file = fopen($target_path, "a");
            $logs->addLog($file, "IMPORT COMMANDE", $th->getMessage(), "ERROR");

        }
    } 

    public function checkIfOrderExist($reference){

        try {
            $url = $this->APIAuth->GetApiPathToCheckIfOrderExist($reference);
            $curl = curl_init();
    
            curl_setopt_array($curl, array(
                CURLOPT_URL => $url,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "GET",
                CURLOPT_HTTPHEADER => array(
                    "ebp-subscription-key: $this->ebp_subscription_key",
                    "Authorization: Bearer $this->access_token"
                ),
            ));
    
            $resp = json_decode(curl_exec($curl),true);

            $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
            if($http_code == "200"){ 
   

                return $resp;
            }else{ 
                echo "Error : ".$http_code." <br> Please check your access TOKEN KEY's to the API.";
            }
            curl_close($curl);
        } catch (\Throwable $th) {
            //throw $th;
            $date = date("YmdHis");

            $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Orders/Imports/Errors/ERROR_ORDER_$date.txt";
            $file = fopen($target_path, "a");
            $logs->addLog($file, "IMPORT COMMANDE", $th->getMessage(), "ERROR");
        }
    } 

    private function getImportErrorsMessage($details)
    {
        $message = null;

        foreach ($details as $detail) {
            $lineNumber = $detail->lineNumber;
            $errors = $detail->errors;
            if (count($errors) > 0) {
                $txt = "Ligne N°$lineNumber => ";
    
                foreach ($errors as $error) {
                    $error_code = $error->code;
                    $error_message = $error->message;
                    $txt .= "[Erreur $error_code] : $error_message \n";
                }
                $message .= $txt;
            }
        }
        return $message;
    }
}
?>
