<?php
class Logs
{
    public function writeImportLog($file, $importInfo, $status)
    {
        $date = date("Y-m-d H:i:s");
        $txt = "Date et heure d'import => $date";
        fwrite($file, $txt . PHP_EOL . PHP_EOL);

        $txt = "######################### importId #########################";
        fwrite($file, $txt . PHP_EOL . PHP_EOL);
        $importId = $importInfo->importId;
        $txt = "ImportId => $importId";
        fwrite($file, $txt . PHP_EOL . PHP_EOL);

        $txt = "######################### fileId #########################";
        fwrite($file, $txt . PHP_EOL . PHP_EOL);
        $fileId = $importInfo->fileId;
        $txt = "fileId => $fileId";
        fwrite($file, $txt . PHP_EOL . PHP_EOL);

        $txt = "######################### importInfos #########################";
        fwrite($file, $txt . PHP_EOL . PHP_EOL);
        $importInfos = $importInfo->importInfos;

        $itemTotal = $importInfos->itemTotal;
        $txt = "itemTotal => $itemTotal";
        fwrite($file, $txt . PHP_EOL . PHP_EOL);


        $itemCreated = $importInfos->itemCreated;
        $txt = "itemCreated => $itemCreated";
        fwrite($file, $txt . PHP_EOL . PHP_EOL);


        $itemUpdated = $importInfos->itemUpdated;
        $txt = "itemUpdated => $itemUpdated";
        fwrite($file, $txt . PHP_EOL . PHP_EOL);
        

        $itemError = $importInfos->itemError;
        $txt = "itemError => $itemError";
        fwrite($file, $txt . PHP_EOL . PHP_EOL);

        
        $txt = "######################### details #########################";
        fwrite($file, $txt . PHP_EOL);
        $details = $importInfos->details;

        if ($status === "success") {
            // Chaque ligne
            foreach ($details as $detail) {
                $lineNumber = $detail->lineNumber;
                $txt = "####### Ligne N°$lineNumber #######";
                fwrite($file, $txt . PHP_EOL . PHP_EOL);

                $created = $detail->created;
                $createdId = $created->id;
                $txt = "Id de création => $createdId";
                fwrite($file, $txt . PHP_EOL . PHP_EOL);
            }
        }

        if ($status === "error") {
            foreach ($details as $detail) {
                $lineNumber = $detail->lineNumber;
                $txt = "####### Ligne N°$lineNumber #######";
                fwrite($file, $txt . PHP_EOL . PHP_EOL);

                $errors = $detail->errors;
                foreach ($errors as $error) {
                    $error_code = $error->code;
                    $error_message = $error->message;
                    $txt = "Code d'erreur => $error_code";

                    fwrite($file, $txt . PHP_EOL);
                    $txt = "Message d'erreur => $error_message";
                    fwrite($file, $txt . PHP_EOL . PHP_EOL);
                }

            }
        }

    }

    public function addLog($file, $title, $message, $type)
    {
        $date = date("Y-m-d H:i:s");
        $txt = "[$type][$date][$title] : $message";
        fwrite($file, $txt . PHP_EOL . PHP_EOL);
        fclose($file);

        if ($type == "SUCCESS") {
            $target_path = $_ENV["EDICONNECT_EBP"]."Logs/";
            $this->logRepport($target_path, "[$title] : $message");
        }else{
            $target_path = $_ENV["EDICONNECT_EBP"]."Logs/Errors";
            $this->logError($target_path, "[$title] : $message");
        }
    }

    public function logRepport($log_filepath, $message)
    {
        $log_file_data = $log_filepath.'/logs_' . date('d-m-y') . '.log';
        $date = date("Y-m-d H:i:s");
        $txt = "[SUCCESS][$date] : $message\n\n\n";

        file_put_contents($log_file_data, $txt, FILE_APPEND);
    }

    public function logError($log_filepath, $message)
    {
        $log_file_data = $log_filepath.'/errors_' . date('d-m-y') . '.log';
        $date = date("Y-m-d H:i:s");
        $txt = "[ERROR][$date] : $message\n\n\n";

        file_put_contents($log_file_data, $txt, FILE_APPEND);
    }
}
?>
