<?php

include_once(dirname(__DIR__).'/vendor/autoload.php');
include_once(dirname(__DIR__)."/Functions/Functions.php");

use Automattic\WooCommerce\Client;

$dotenv = Dotenv\Dotenv::createImmutable(dirname(__DIR__));
$dotenv->load();

$repo = $_ENV['EXPORT_REPO'];
$success = $_GET['success'];
$itemId = $_GET['itemId'];
$sysModifiedDate = $_GET['sysModifiedDate'];
$active = $_GET['active'];
$dir = $_GET['dir'];

try {
    
    if (
        $repo &&
        $itemId &&
        $sysModifiedDate
    ) {
        $functions = new Functions();
        $result = $functions->checkFileSuccess($repo, "Products/" . ($dir != "" ? "$dir/" : ""), $success, "products_syncro", "product_id", $itemId, $sysModifiedDate, $active);

        if ($result) {
            print_r(json_encode($result, JSON_PRETTY_PRINT));
        }else {
            print_r(json_encode([
                "error" => false,
                "message" => "Une erreur s'est produite sur la fonction 'checkFileSuccess'"
            ], JSON_PRETTY_PRINT));
        }

    }else {
        print_r(json_encode([
            "error" => false,
            "message" => "Un ou plusieurs champs sont vides."
        ], JSON_PRETTY_PRINT));
}
} catch (\Throwable $th) {
    print_r(json_encode([
        "success" => false,
        "message" => $th->getMessage()
    ], JSON_PRETTY_PRINT));
}