<?php
include_once("Functions/Logs.php");

class CustomerModel
{
    public function Export($data){
        $logs = new Logs();
        $current_date = date('dmyHis');

        try {
            
            if ($data["paging"]["returned"] > 0) {
                $customers = $data['results'];
                foreach ($customers as $customer){

                    $customerId = $customer["Id"];
                    $filepath = $_ENV["EDICONNECT_EBP"]."/Exports/Customers/";
                    $filename = "customer_$customerId-$current_date.csv";
                    $file_import_path = $filepath . $filename;
        
                    $new_file = fopen($file_import_path, 'w');
                    $file_line = "";

                    foreach ($customer as $key => $value) {
                        // enlève les retours à la ligne
                        $value = trim(preg_replace('/\s\s+/', ' ', $value));
                        $file_line .= "$key;$value\n";
                    }
                    fputs($new_file, $file_line);
    
                    fclose($new_file);

                    $message = '[SUCCESS] Génération du fichier d\'export du client '. $customer["Id"] . ' réussie.';
    
                    $target_path = $parent_dir . "Logs/Customers/Exports/";
                    $logs->logRepport($target_path, $message);
                }
                return true;
            }else {
                return false;
            }
        } catch (\Throwable $th) {
            //throw $th;
            return false;
        }

    }

    public function exportAll($customers){
        $logs = new Logs();
        $current_date = date('dmyHis');

        foreach ($customers as $customer){
            try {
                $customerId = $this->replaceSpecialChar($customer["Id"]);
                $filepath = $_ENV["EDICONNECT_EBP"]."/Imports/Customers/";
                $filename = "customer_$customerId.csv";
                $file_import_path = $filepath . $filename;
    
                $new_file = fopen($file_import_path, 'w');
                $file_line = "";

                foreach ($customer as $key => $value) {
                    // enlève les retours à la ligne
                    $value = trim(preg_replace('/\s\s+/', ' ', $value));
                    $file_line .= "$key;$value\n";
                }
                fputs($new_file, $file_line);

                fclose($new_file);

                print '[SUCCESS] Export Customer : '.$customer["Name"].' - ID :'.$customer["Name"].'<br>';

                $message = '[SUCCESS] Génération du fichier d\'export du client '. $customer["Id"] . ' réussie.';

                $target_path = $parent_dir . "Logs/Customers/Exports/";
                $logs->logRepport($target_path, $message);


            } catch (\Throwable $th) {
                //throw $th;
                $target_path = $parent_dir . "Logs/Customers/Exports/Errors/";
                $logs->logError($target_path, $th->getMessage());
            }
        }
    }

    public 	function replaceSpecialChar($str) {
		$utf8 = array(
			'/[áàâãªä]/u'   =>   'a',
			'/[ÁÀÂÃÄ]/u'    =>   'A',
			'/[ÍÌÎÏ]/u'     =>   'I',
			'/[íìîï]/u'     =>   'i',
			'/[éèêë]/u'     =>   'e',
			'/[ÉÈÊË]/u'     =>   'E',
			'/[óòôõºö]/u'   =>   'o',
			'/[ÓÒÔÕÖ]/u'    =>   'O',
			'/[úùûü]/u'     =>   'u',
			'/[ÚÙÛÜ]/u'     =>   'U',
			'/ç/'           =>   'c',
			'/Ç/'           =>   'C',
			'/ñ/'           =>   'n',
			'/Ñ/'           =>   'N',
			'/,/'           =>   '_',
			'/–/'           =>   '_',
			"/[’‘‹›‚']/u"   =>   '_',
			'/[“”«»„]/u'    =>   '_', 
			'/ /'           =>   '_',
			'/\//'           =>   '_',
		);
		return strtolower(preg_replace(array_keys($utf8), array_values($utf8), $str));
	}
}
?>
