<?php
include_once($_ENV["EDICONNECT_EBP"]."Functions/Logs.php");

class ProductModel
{
    public function Export($data){
        $logs = new Logs();
        $current_date = date('dmyHis');

        if ($data["paging"]["returned"] > 0) {
            $products = $data['results'];
            foreach ($products as $product){
                
                try {
                    $productId = $product["Item_Id"];
                    $filepath = $_ENV["EDICONNECT_EBP"]."/Exports/Products/";
                    $filename = "product_$productId-$current_date.csv";
                    $file_import_path = $filepath . $filename;
        
                    $new_file = fopen($file_import_path, 'w');
                    $file_line = "";

                    foreach ($product as $key => $value) {
                        // enlève les retours à la ligne
                        $value = trim(preg_replace('/\s\s+/', ' ', $value));
                        $file_line .= "$key;$value\n";
                    }
                    fputs($new_file, $file_line);
    
                    fclose($new_file);

                    $message = '[SUCCESS] Génération du fichier d\'export du produit '. $product["Item_Id"] . ' réussie.';
    
                    $target_path = $parent_dir . "Logs/Products/Exports/";
                    $logs->logRepport($target_path, $message);

                    return true;

                } catch (\Throwable $th) {
                    //throw $th;
                    $target_path = $parent_dir . "Logs/Products/Exports/Errors/";
                    $logs->logError($target_path, $th->getMessage());
                    return false;
                }
            }
        }

    }

    public function exportAll($products){
        $logs = new Logs();
        $current_date = date('dmyHis');

        foreach ($products as $product){
            try {
                $productId = $product["Id"];
                $filepath = $_ENV["EDICONNECT_EBP"]."/Exports/Products/";
                $filename = "product_$productId-$current_date.csv";
                $file_import_path = $filepath . $filename;
    
                $new_file = fopen($file_import_path, 'w');
                $file_line = "";

                foreach ($product as $key => $value) {
                    // enlève les retours à la ligne
                    $value = trim(preg_replace('/\s\s+/', ' ', $value));
                    $file_line .= "$key;$value\n";
                }
                fputs($new_file, $file_line);

                fclose($new_file);

                $message = '[SUCCESS] Génération du fichier d\'export du produit '. $product["Id"] . ' réussie.';

                $target_path = $parent_dir . "Logs/Products/Exports/";
                $logs->logRepport($target_path, $message);


            } catch (\Throwable $th) {
                //throw $th;
                $target_path = $parent_dir . "Logs/Products/Exports/Errors/";
                $logs->logError($target_path, $th->getMessage());
            }
        }
    }

    public function Delete($product){
        $logs = new Logs();
        $current_date = date('dmyHis');

        if (!empty($product)) {
                try {
                    $productId = $product["Id"];
                    $filepath = "/var/www/html/freshxpress/EDIConnect_EBP/Exports/Products/Delete/";

                    $filename = "product_$productId-$current_date.csv";
                    $file_import_path = $filepath . $filename;
        
                    $new_file = fopen($file_import_path, 'w');
                    $file_line = "";

                    foreach ($product as $key => $value) {
                        // enlève les retours à la ligne
                        $value = trim(preg_replace('/\s\s+/', ' ', $value));
                        $file_line .= "$key;$value\n";
                    }
                    fputs($new_file, $file_line);
    
                    fclose($new_file);

                    $message = '[SUCCESS] Génération du fichier de suppression du produit '. $product["Id"] . ' réussie.';
    
                    $target_path = $parent_dir . "Logs/Products/Deletes/";
                    $logs->logRepport($target_path, $message);
                    return true;

                } catch (\Throwable $th) {
                    //throw $th;
                    $target_path = $parent_dir . "Logs/Products/Deletes/Errors/";
                    $logs->logError($target_path, $th->getMessage());
                    return false;
                }
        }

    }
}
?>
